// --------------------------------------------------------------------
// Author  : mashimonator
// Create  : 2009/12/07
// Update  : 2009/12/07
// Description : table要素を装飾する
// --------------------------------------------------------------------

/*@cc_on 
var doc = document;
eval('var document = doc');
@*/
var tableDecorateExtension = {
	//-----------------------------------------
	// 設定値
	//-----------------------------------------
	conf : {
		targetClass : 'decorate',
		oddColor : '#fff',
		evenColor : '#f8f8ff',
		hoverColor : '#ecf0e7',
		activeColor : '#fff5ee',
		enteredColor : '#fff5ee',
		checkedColor : '#fff5ee',
		autoZoomSize : '120%',
		focusZoomSize : '140%'
	},
	flags : {
		stripe : false,
		hover : false,
		active : false,
		autoZoom : false,
		focusZoom : false,
		entered : false,
		checked : false,
		pointer : false
	},
	storage : {
		blurTr : null,
		fZoomState : true
	},
	//-----------------------------------------
	// 初期処理
	//-----------------------------------------
	init : function() {
		var tables = tableDecorateExtension.getTargetElements( 'table', tableDecorateExtension.conf.targetClass);
		var reg = new RegExp(tableDecorateExtension.conf.targetClass + '\\[.+?\\]', 'i');
		for ( var i = 0, len = tables.length; i < len; i++ ) {
			// オプション取得
			tableDecorateExtension.getOption(tables[i].className.match(reg));
			tables[i].className = tables[i].className.replace(reg, tableDecorateExtension.conf.targetClass);
			// tr要素取得
			var tr = tables[i].getElementsByTagName('tr');
			var odd = true;
			for ( var x = 0, len2 = tr.length; x < len2; x++ ) {
				// ヘッダのチェック
				if ( tableDecorateExtension.checkHeader(tr[x]) ) {
					continue;
				}
				// クラスセット（stripe）
				if ( tableDecorateExtension.flags.stripe ) {
					tr[x].className = tr[x].className.replace(/ odd/g,'');
					tr[x].className = tr[x].className.replace(/odd/g,'');
					tr[x].className = tr[x].className.replace(/ even/g,'');
					tr[x].className = tr[x].className.replace(/even/g,'');
					if ( odd ) {
						// 奇数行
						tr[x].className += ' odd';
						odd = false;
					} else {
						// 偶数行
						tr[x].className += ' even';
						odd = true;
					}
				}
				// イベント付加（hover）
				if ( tableDecorateExtension.flags.hover ) {
					tableDecorateExtension.addEvent(tr[x], 'mouseover', tableDecorateExtension.mouseoverHover);
					tableDecorateExtension.addEvent(tr[x], 'mouseout', tableDecorateExtension.mouseoutHover);
				}
				// イベント付加（autoZoom）
				if ( tableDecorateExtension.flags.autoZoom ) {
					tableDecorateExtension.addEvent(tr[x], 'mouseover', tableDecorateExtension.mouseoverAZoom);
					tableDecorateExtension.addEvent(tr[x], 'mouseout', tableDecorateExtension.mouseoutAZoom);
				}
				// イベント付加（active & focusZoom & edited & pointer）
				var input = tr[x].getElementsByTagName('INPUT');
				for ( var z = 0, len3 = input.length; z < len3; z++ ) {
					input[z].parentTr = tr[x];
					if ( tableDecorateExtension.flags.active ) {
						tableDecorateExtension.addEvent(input[z], 'focus', tableDecorateExtension.focusActive);
						tableDecorateExtension.addEvent(input[z], 'blur', tableDecorateExtension.blurActive);
					}
					if ( tableDecorateExtension.flags.focusZoom ) {
						tableDecorateExtension.addEvent(input[z], 'focus', tableDecorateExtension.focusFZoom);
						tableDecorateExtension.addEvent(input[z], 'blur', tableDecorateExtension.blurFZoom);
					}
					if ( tableDecorateExtension.flags.entered ) {
						tableDecorateExtension.addEvent(input[z], 'blur', tableDecorateExtension.blurEntered);
					}
					if ( tableDecorateExtension.flags.checked ) {
						tableDecorateExtension.addEvent(input[z], 'click', tableDecorateExtension.clickChecked);
					}
				}
				var label = tr[x].getElementsByTagName('LABEL');
				for ( var z = 0, len3 = label.length; z < len3; z++ ) {
					label[z].parentTr = tr[x];
					if ( tableDecorateExtension.flags.focusZoom ) {
						tableDecorateExtension.addEvent(label[z], 'mousedown', tableDecorateExtension.mousedownFZoom);
						tableDecorateExtension.addEvent(label[z], 'mouseup', tableDecorateExtension.mouseupFZoom);
					}
					if ( tableDecorateExtension.flags.pointer ) {
						label[z].style.cursor = 'pointer';
					}
				}
				var select = tr[x].getElementsByTagName('SELECT');
				for ( var z = 0, len3 = select.length; z < len3; z++ ) {
					select[z].parentTr = tr[x];
					if ( tableDecorateExtension.flags.active ) {
						tableDecorateExtension.addEvent(select[z], 'focus', tableDecorateExtension.focusActive);
						tableDecorateExtension.addEvent(select[z], 'blur', tableDecorateExtension.blurActive);
					}
					if ( tableDecorateExtension.flags.focusZoom ) {
						tableDecorateExtension.addEvent(select[z], 'focus', tableDecorateExtension.focusFZoom);
						tableDecorateExtension.addEvent(select[z], 'blur', tableDecorateExtension.blurFZoom);
					}
					if ( tableDecorateExtension.flags.entered ) {
						tableDecorateExtension.addEvent(select[z], 'blur', tableDecorateExtension.blurEntered);
					}
					if ( tableDecorateExtension.flags.focusZoom ) {
						tableDecorateExtension.addEvent(select[z], 'mouseup', tableDecorateExtension.mouseupFZoom);
					}
				}
				var textarea = tr[x].getElementsByTagName('TEXTAREA');
				for ( var z = 0, len3 = textarea.length; z < len3; z++ ) {
					textarea[z].parentTr = tr[x];
					if ( tableDecorateExtension.flags.active ) {
						tableDecorateExtension.addEvent(textarea[z], 'focus', tableDecorateExtension.focusActive);
						tableDecorateExtension.addEvent(textarea[z], 'blur', tableDecorateExtension.blurActive);
					}
					if ( tableDecorateExtension.flags.focusZoom ) {
						tableDecorateExtension.addEvent(textarea[z], 'focus', tableDecorateExtension.focusFZoom);
						tableDecorateExtension.addEvent(textarea[z], 'blur', tableDecorateExtension.blurFZoom);
					}
					if ( tableDecorateExtension.flags.entered ) {
						tableDecorateExtension.addEvent(textarea[z], 'blur', tableDecorateExtension.blurEntered);
					}
				}
			}
		}
		// スタイル適用
		if ( tableDecorateExtension.conf.oddColor && tableDecorateExtension.conf.oddColor != '' ) {
			tableDecorateExtension.addCssRule('.' + tableDecorateExtension.conf.targetClass + ' tr.odd td', 'background-color:' + tableDecorateExtension.conf.oddColor + ';');
		}
		if ( tableDecorateExtension.conf.evenColor && tableDecorateExtension.conf.evenColor != '' ) {
			tableDecorateExtension.addCssRule('.' + tableDecorateExtension.conf.targetClass + ' tr.even td', 'background-color:' + tableDecorateExtension.conf.evenColor + ';');
		}
		if ( tableDecorateExtension.conf.enteredColor && tableDecorateExtension.conf.enteredColor != '' ) {
			tableDecorateExtension.addCssRule('.' + tableDecorateExtension.conf.targetClass + ' tr.entered td,tr.entered th', 'background-color:' + tableDecorateExtension.conf.enteredColor + ' !important;');
		}
		if ( tableDecorateExtension.conf.checkedColor && tableDecorateExtension.conf.checkedColor != '' ) {
			tableDecorateExtension.addCssRule('.' + tableDecorateExtension.conf.targetClass + ' tr.checked td,tr.checked th', 'background-color:' + tableDecorateExtension.conf.checkedColor + ' !important;');
		}
		if ( tableDecorateExtension.conf.activeColor && tableDecorateExtension.conf.activeColor != '' ) {
			tableDecorateExtension.addCssRule('.' + tableDecorateExtension.conf.targetClass + ' tr.active td,tr.active th', 'background-color:' + tableDecorateExtension.conf.activeColor + ' !important;');
		}
		if ( tableDecorateExtension.conf.hoverColor && tableDecorateExtension.conf.hoverColor != '' ) {
			tableDecorateExtension.addCssRule('.' + tableDecorateExtension.conf.targetClass + ' tr.hover td', 'background-color:' + tableDecorateExtension.conf.hoverColor + ' !important;');
		}
	},
	//-----------------------------------------
	// mouseover（hover）
	//-----------------------------------------
	mouseoverHover : function() {
		this.className += ' hover';
	},
	//-----------------------------------------
	// mouseout（hover）
	//-----------------------------------------
	mouseoutHover : function() {
		this.className = this.className.replace(/ hover/g,'');
		this.className = this.className.replace(/hover/g,'');
	},
	//-----------------------------------------
	// mouseover（autoZoom）
	//-----------------------------------------
	mouseoverAZoom : function() {
		this.style.fontSize = tableDecorateExtension.conf.autoZoomSize;
	},
	//-----------------------------------------
	// mouseout（autoZoom）
	//-----------------------------------------
	mouseoutAZoom : function() {
		this.style.fontSize = '100%';
	},
	//-----------------------------------------
	// focus（active）
	//-----------------------------------------
	focusActive : function() {
		this.parentTr.className += ' active';
	},
	//-----------------------------------------
	// blur（active）
	//-----------------------------------------
	blurActive : function() {
		this.parentTr.className = this.parentTr.className.replace(/ active/g,'');
		this.parentTr.className = this.parentTr.className.replace(/active/g,'');
	},
	//-----------------------------------------
	// mousedown（focusZoom）
	//-----------------------------------------
	mousedownFZoom : function() {
		tableDecorateExtension.storage.fZoomState = false;
		if ( tableDecorateExtension.storage.blurTr && tableDecorateExtension.storage.blurTr != this.parentTr ) {
			tableDecorateExtension.storage.blurTr.style.fontSize = '100%';
		}
	},
	//-----------------------------------------
	// mouseup（focusZoom）
	//-----------------------------------------
	mouseupFZoom : function() {
		tableDecorateExtension.storage.fZoomState = true;
		tableDecorateExtension.storage.blurTr = this.parentTr;
	},
	//-----------------------------------------
	// focus（focusZoom）
	//-----------------------------------------
	focusFZoom : function() {
		tableDecorateExtension.storage.blurTr = this.parentTr;
		this.parentTr.style.fontSize = tableDecorateExtension.conf.focusZoomSize;
	},
	//-----------------------------------------
	// blur（focusZoom）
	//-----------------------------------------
	blurFZoom : function() {
		if ( tableDecorateExtension.storage.fZoomState ) {
			this.parentTr.style.fontSize = '100%';
		}
	},
	//-----------------------------------------
	// blur（entered）
	//-----------------------------------------
	blurEntered : function() {
		if ( !this.value ) {
			this.parentTr.className = this.parentTr.className.replace(/ entered/g,'');
			this.parentTr.className = this.parentTr.className.replace(/entered/g,'');
		} else {
			this.parentTr.className += ' entered';
		}
	},
	//-----------------------------------------
	// click（checked）
	//-----------------------------------------
	clickChecked : function() {
		if ( !this.checked ) {
			this.parentTr.className = this.parentTr.className.replace(/ checked/g,'');
			this.parentTr.className = this.parentTr.className.replace(/checked/g,'');
		} else {
			this.parentTr.className += ' checked';
		}
	},
	//-----------------------------------------
	// tr要素にtd要素が含まれているかをチェックする
	//-----------------------------------------
	checkHeader : function( tr ) {
		var parent = tr.parentNode;
		if ( parent.nodeName && parent.nodeName.match(/thead/i) ) {
			return true;
		}
		var td = tr.getElementsByTagName('td');
		if ( td && td.length > 0 ) {
			return false;
		} else {
			return true;
		}
	},
	//-----------------------------------------
	// Class名からオプションを抽出する
	//-----------------------------------------
	getOption : function( str ) {
		if ( str && str != '' ) {
			// フラグリセット
			tableDecorateExtension.resetFlags();
			// クラス名からオプション抜き出し
			str += '';
			str = str.replace(tableDecorateExtension.conf.targetClass, '');
			str = str.replace('[', '');
			str = str.replace(']', '');
			str = str.split(',');
			// オプションの判定
			for ( var i = 0, len = str.length; i < len; i++ ) {
				if ( str[i].match(/stripe/i) ) {
					tableDecorateExtension.flags.stripe = true;
				}
				if ( str[i].match(/hover/i) ) {
					tableDecorateExtension.flags.hover = true;
				}
				if ( str[i].match(/active/i) ) {
					tableDecorateExtension.flags.active = true;
				}
				if ( str[i].match(/autoZoom/i) ) {
					tableDecorateExtension.flags.autoZoom = true;
				}
				if ( str[i].match(/focusZoom/i) ) {
					tableDecorateExtension.flags.focusZoom = true;
				}
				if ( str[i].match(/entered/i) ) {
					tableDecorateExtension.flags.entered = true;
				}
				if ( str[i].match(/checked/i) ) {
					tableDecorateExtension.flags.checked = true;
				}
				if ( str[i].match(/pointer/i) ) {
					tableDecorateExtension.flags.pointer = true;
				}
			}
		}
	},
	//-----------------------------------------
	// フラグをリセットする
	//-----------------------------------------
	resetFlags : function() {
		tableDecorateExtension.flags.stripe = false;
		tableDecorateExtension.flags.hover = false;
		tableDecorateExtension.flags.active = false;
		tableDecorateExtension.flags.autoZoom = false;
		tableDecorateExtension.flags.focusZoom = false;
		tableDecorateExtension.flags.entered = false;
		tableDecorateExtension.flags.checked = false;
		tableDecorateExtension.flags.pointer = false;
	},
	//-----------------------------------------
	// スタイルシートに規則を追加する
	//-----------------------------------------
	addCssRule : function( selector, declarations ) {
		var sheets = document.styleSheets;
		if ( sheets ) {
			if ( sheets.length < 1 ) {
				// 外部読み込みのスタイルシートが無い場合
				var style = document.createElement('style');
				style.setAttribute('type', 'text/css');
				style.innerHTML += selector + '{' + declarations + '}';
				var head = document.getElementsByTagName('HEAD');
				head[0].appendChild(style);
			} else {
				// 一番最後のスタイルシートを取得
				var tSheet = sheets[sheets.length - 1];
				if ( document.all ) {
					// iIndexは省略可。省略するとスタイルシートの最後に追加
					tSheet.addRule( selector, declarations );
				} else {
					// ruleはセレクタと宣言ブロック。被挿入規則のインデックスが返る
					tSheet.insertRule( selector + '{' + declarations + '}', tSheet.cssRules.length );
				}
			}
		}
	},
	//-----------------------------------------
	// ターゲットタグを取得する
	//-----------------------------------------
	getTargetElements : function( tag, cls ) {
		var elements = new Array();
		var targetElements = document.getElementsByTagName(tag.toUpperCase());
		for ( var i = 0, len = targetElements.length; i < len; i++ ) {
			if ( targetElements[i].className.match(cls) ) {
				elements[elements.length] = targetElements[i];
			}
		}
		return elements;
	},
	//-----------------------------------------
	// イベントに関数を付加する
	//-----------------------------------------
	addEvent : function( target, event, func ) {
		try {
			target.addEventListener(event, func, false);
		} catch (e) {
			target.attachEvent('on' + event, (function(el){return function(){func.call(el);};})(target));
		}
	}
}
// 実行
tableDecorateExtension.addEvent( window, 'load', tableDecorateExtension.init );